# META NAME replace open dialog with pd_gtk_open gtk application
# META DESCRIPTION Gives you a gtk-looking open. Requires the pd_gtk_open binary
# META AUTHOR <Lorenzo Sutton> lsutton@libero.it
package require Tcl 8.5
package require Tk
package require pdwindow 0.1
package require pd_menus 0.1
package require pd_menucommands 0.1

rename ::pd_menucommands::menu_open ::pd_menucommands::menu_open_old

# yvan
set ::pd_gtk_open_path ""

proc ::gtk_open_init {} {
    set ::pd_gtk_open_path $::current_plugin_loadpath/bin/pd_gtk_open
}
# end yvan

proc ::pd_menucommands::menu_open {} {
    #pdtk_post $::current_plugin_loadpath
    #set pd_gtk_open_path $::current_plugin_loadpath/bin/pd_gtk_open
    set gtk_ok 0
    #pdtk_post "RUNNING GTK OPEN: $pd_gtk_open_path\n"
    if {[file exists $::pd_gtk_open_path]} {    
        set files ""
        if {! [catch {exec $::pd_gtk_open_path $::fileopendir} fileList]} {
            #puts "Using pd_gtk_open"
            set files [split $fileList "|"]
            set gtk_ok 1
        }
    # if the executable pd_gtk_open is not found fall-back to tk
    } else {
        pdtk_post "\nWARNING: pd_gtk_open binary NOT found: $::pd_gtk_open_path. Using Tk open.\n"
        if { ! [file isdirectory $::fileopendir]} {set ::fileopendir $::env(HOME)}
        set files [tk_getOpenFile -defaultextension .pd \
	                       -multiple true \
	                       -filetypes $::filetypes \
	                       -initialdir $::fileopendir]
    }
    if {$files ne ""} {
        foreach filename $files { 
            open_file $filename
        }
        set ::fileopendir [file dirname $filename]
    }
}

::gtk_open_init ;# yvan

rename menu_open menu_open_old
namespace import ::pd_menucommands::menu_open
