# META NAME replace save dialog with pd_gtk_open gtk application
# META DESCRIPTION Gives you a gtk-looking open. Requires the pd_gtk_open binary
# META AUTHOR <Lorenzo Sutton> lsutton@libero.it
package require Tcl 8.5
package require Tk
package require pdwindow 0.1
package require pd_menus 0.1
package require pd_menucommands 0.1
package require pdtk_canvas 0.1

rename pdtk_canvas_saveas pdtk_canvas_saveas_old

# yvan
set ::pd_gtk_save_path ""

proc ::gtk_save_init {} {
    set ::pd_gtk_save_path $::current_plugin_loadpath/bin/pd_gtk_save
}
# end yvan

proc pdtk_canvas_saveas {name initialfile initialdir} {
    #set pd_gtk_save_path $::current_plugin_loadpath/bin/pd_gtk_save
    set gtk_ok 0
    if { ! [file isdirectory $initialdir]} {set initialdir $::env(HOME)}    
#    pdtk_post "RUNNING GTK SAVE: $pd_gtk_save_path\n"
    if {[file exists $::pd_gtk_save_path]} {
        if {! [catch {exec $::pd_gtk_save_path $initialdir $initialfile} filename]} {        
        #if {! [catch {exec $pd_gtk_save_path $initialdir $initialfile} filename]}
            pdtk_post "save to $filename"
            set usingTk 0
            set gtk_ok 1
        }
  		if {$filename eq ""} return; # Cancel
    } else {
        # if the executable pd_gtk_save is not found fall-back to usual tk    
        pdtk_post "\nWARNING: pd_gtk_save binary NOT found: $::pd_gtk_save_path. Using Tk save\n"        
        set filename [tk_getSaveFile -initialfile $initialfile -initialdir $initialdir \
                          -defaultextension .pd -filetypes $::filetypes]
        if {$filename eq ""} return; # they clicked cancel
    }
    set extension [file extension $filename]
    set oldfilename $filename
    set filename [regsub -- "$extension$" $filename [string tolower $extension]]
    if { ! [regexp -- "\.(pd|pat|mxt)$" $filename]} {
        # we need the file extention even on Mac OS X
        set filename $filename.pd
    }
    # test again after downcasing and maybe adding a ".pd" on the end
    if {$filename ne $oldfilename && [file exists $filename]} {
        set answer [tk_messageBox -type okcancel -icon question -default cancel\
                        -message [_ "\"$filename\" already exists. Do you want to replace it?"]]
        if {$answer eq "cancel"} return; # they clicked cancel
    }
    set dirname [file dirname $filename]
    set basename [file tail $filename]
    pdsend "$name savetofile [enquote_path $basename] [enquote_path $dirname]"
    set ::filenewdir $dirname  
}

::gtk_save_init ;# yvan

#rename pdtk_canvas_saveas pdtk_canvas_saveas_old_
#namespace import pdtk_canvas::pdtk_canvas_saveas
